// Update checker - Copyright Logiciels Malus Softwares 2005 (http://www.malus.ca)
//
// Version 2.0

// **************** PUBLIC API ****************
function widget_vcheck_textdb(pUpdateDatabaseURL, pVersionAttributeName, pResponseHandler) 
{ 
   widget_vcheck_getDB(pUpdateDatabaseURL, widget_vcheck_receive_textdb, { handler: pResponseHandler, version_attribute: pVersionAttributeName }); 
}


// **************** PRIVATE API ****************
function widget_vcheck_receive_textdb(pResponse, pUserInfos) {

	if(pResponse == null) {
		pUserInfos.handler(false);
		return;
	}
	var vResponseText = pResponse.responseText;
	
	try {
		var vLines = vResponseText.match(/^.*$/gm);
		
		var vDBVersion = null;
		for(var vLoop = 0; vLoop < vLines.length; vLoop++) {
			var vInfos = vLines[vLoop].match(/(.+)\t(.+)/);
			if(vInfos != null) {
				vDBVersion = vInfos[2];
				break;
			}
		}
	} catch(vException) { pUserInfos.handler(false); return; }
	
	widget_vcheck(vDBVersion, pUserInfos);
}
function widget_vcheck(pDBVersion, pUserInfos) {
	if(pDBVersion == null) {
		pUserInfos.handler(false);
		return;
	}
	
	var vWidgetVersion = getKeyValueFromFile("Info.plist", "CFBundleVersion");

	pUserInfos.handler((parseFloat(vWidgetVersion) < parseFloat(pDBVersion) ));
}

var gwidget_vcheck_request = null;

function widget_vcheck_getDB(pUpdateDatabaseURL, pResponseHandler, pUserInfos) {
	if(pUpdateDatabaseURL == null) { pUserInfos.handler(false); return; }
	
	// get db file, return string content
	gwidget_vcheck_request = new XMLHttpRequest();
	gwidget_vcheck_request.responseHandler = pResponseHandler;
	gwidget_vcheck_request.userInfos = pUserInfos;
	gwidget_vcheck_request.onreadystatechange = widget_vcheck_db_receive;
	gwidget_vcheck_request.open("GET", pUpdateDatabaseURL,true);
	gwidget_vcheck_request.setRequestHeader("Cache-Control", "no-cache");
	gwidget_vcheck_request.send(null);
}
function widget_vcheck_db_receive() {
	if(gwidget_vcheck_request == null) return;
	if(gwidget_vcheck_request.readyState != 4) return;
	if(gwidget_vcheck_request.status == 200) {
		if(gwidget_vcheck_request.responseHandler != null) gwidget_vcheck_request.responseHandler(gwidget_vcheck_request, gwidget_vcheck_request.userInfos);
	} else {
		alert("widget_update_checker failed: " + gwidget_vcheck_request.responseText);
		gwidget_vcheck_request.userInfos.handler(false);
	}
}

function getKeyValueFromFile(pPlist, pKey) {
	var vXML_HTTP = new XMLHttpRequest();
	vXML_HTTP.open("GET", pPlist, false);
	vXML_HTTP.send(null);
	
	var vXML = vXML_HTTP.responseXML;
	
	return getKeyValue(vXML, pKey);
}
function getKeyValue(pPlist, pKey) {
	var vNodeIterator = pPlist.createNodeIterator(pPlist.documentElement.childNodes[1], NodeFilter.SHOW_ELEMENT, null, false);
	var vResult;
	var vNode = vNodeIterator.nextNode(); // discard root
	
	while(vNode = getNextNodeNamed(vNodeIterator, "key")) {
		var vKeyName = vNode.firstChild.data;
		vNode = vNodeIterator.nextNode();
		if(vNode && (vKeyName == pKey)) { return vNode.firstChild.data; }
	}
	
	return null;
}
function getNextNodeNamed(pNodeIterator, pNodeName) {
	do {
		var vNode = pNodeIterator.nextNode();
		if(vNode && (vNode.nodeName == pNodeName)) return vNode;
	} while(vNode);
	return null;
}